
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
 
public class JSpinnerExample extends JFrame {
 
  public JSpinnerExample() {
    GregorianCalendar calendar = new GregorianCalendar();
    Date now = calendar.getTime();
 
    SpinnerDateModel timeModel = new SpinnerDateModel(
        now, null, null, Calendar.MINUTE);
    JSpinner timeSpinner = new JSpinner(timeModel);
    JFormattedTextField  timeField =
      ((JSpinner.DefaultEditor)timeSpinner.getEditor()).
                                           getTextField();
    DefaultFormatterFactory timeFactory =
      (DefaultFormatterFactory)timeField.getFormatterFactory();
    DateFormatter timeFormatter =
      (DateFormatter)timeFactory.getDefaultFormatter();
    timeFormatter.setFormat(new SimpleDateFormat("HH:mm"));
 
    SpinnerDateModel dateModel = new SpinnerDateModel(
        now, null, null, Calendar.DAY_OF_WEEK);
    JSpinner dateSpinner = new JSpinner(dateModel);
    JFormattedTextField  dateField =
      ((JSpinner.DefaultEditor)dateSpinner.getEditor()).
                                           getTextField();
    DefaultFormatterFactory dateFactory =
      (DefaultFormatterFactory)dateField.getFormatterFactory();
    DateFormatter dateFormatter =
      (DateFormatter)dateFactory.getDefaultFormatter();
    dateFormatter.setFormat(new SimpleDateFormat("dd.MM.yyyy"));
 
    JPanel panel = new JPanel();
    panel.add(timeSpinner);
//    panel.add(dateSpinner);
    getContentPane().add(panel, BorderLayout.CENTER);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setSize(300,200);
    setLocation(400,100);
    setVisible(true);
    // this is a trick - I can't figure out how
    // to get both of these to work at the same time
    // focus clears the extra date entry in dateSpinner...
//    dateField.requestFocus();
  }
 
  public static void main(String[] args) {
    new JSpinnerExample();
  }
}

