package com.filemaker.client;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.swing.JSpinner;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.ulcjava.base.client.UIComponent;
import com.ulcjava.base.client.util.IChangedListener;
import com.ulcjava.base.client.util.IEnablingSource;
import com.ulcjava.base.client.util.IEnablingTarget;
import com.ulcjava.base.client.util.IHasChangedSource;

public class UISpinner extends UIComponent 
	implements ChangeListener, IEnablingSource, IHasChangedSource, IEnablingTarget {
	 
	private List<IEnablingTarget> enablingTargets = new ArrayList<IEnablingTarget>();
	private Vector<IChangedListener> changedListeners = new Vector<IChangedListener>() ;
		 
	protected class BasicSpinner extends JSpinner {
		public BasicSpinner() {
		}

		public BasicSpinner(SpinnerModel model) {
			super(model);
		}
	}

	@Override
	protected Object createBasicObject(Object[] o) {
		Number value = (Number) o[0];
		Comparable min = (Comparable)o[1] ;
		Comparable max = (Comparable)o[2] ;
		Number stepSize = (Number)o[3] ;
		SpinnerNumberModel model = new SpinnerNumberModel();
		if (value != null)
			model.setValue(value);
		if (min != null)
			model.setMinimum(min);
		if (max != null)
			model.setMaximum(max);
		if (stepSize != null)
			model.setStepSize(stepSize);
		return new BasicSpinner(model);
	}

	public BasicSpinner getBasicSpinner() {
		return (BasicSpinner) getBasicObject();
	}
		    
	@Override
	protected void postInitializeState() {
		super.postInitializeState();		
		getModel().addChangeListener(this);
	}
	
	public SpinnerNumberModel getModel() {
		return (SpinnerNumberModel) getBasicSpinner().getModel() ;
	}

	public void addTarget(IEnablingTarget ienablingtarget) {
		enablingTargets.add(ienablingtarget);
		ienablingtarget.setEnabled(isEnabling());
	}
		    
	public boolean isEnabling() {
		return getBasicSpinner().getValue() != null;
	}

	public void removeTarget(IEnablingTarget ienablingtarget) {
		enablingTargets.remove(ienablingtarget);
	}

	private void updateEnablingTargets() {
		Iterator<IEnablingTarget> iterator = enablingTargets.iterator();
		while (iterator.hasNext()) {
			IEnablingTarget ienablingtarget = iterator.next();
			ienablingtarget.setEnabled(isEnabling());
		}
	}

	public void addHasChangedListener(IChangedListener arg0) {
		changedListeners.add(arg0);
	}

	public void removeHasChangedListener(IChangedListener arg0) {
		changedListeners.remove(arg0);
	}
	
	public void stateChanged(ChangeEvent e) {
		updateEnablingTargets();
	    updateStateULC("value", getValue());
	    fireValueChangedULC();
	    for(IChangedListener l : changedListeners)
	    	l.changed() ;
	}
	
	  protected void fireValueChangedULC() {
			fireMandatoryEventULC("valueChanged", "valueChanged", EMPTY_ARGUMENTS);
	  }
		    
	
	public Object getValue() {
		return getBasicSpinner().getValue();		
	}

	public void setMaximum(Comparable max) {
		 getModel().setMaximum(max);
	 }

	 public void setMinimum(Comparable min) {
		 getModel().setMinimum(min);
	 }

	 public void setStepSize(Number stepSize) {
		 getModel().setStepSize(stepSize);
	 }
	 
	 public void setValue(Number n) {
		 getModel().setValue(n);
	 }	
}
