package com.filemaker.server;

import java.util.Date;

import com.ulcjava.base.application.ULCComponent;
import com.ulcjava.base.application.ULCProxy;
import com.ulcjava.base.application.enabler.IEnabler;
import com.ulcjava.base.application.enabler.IHasChangedSource;
import com.ulcjava.base.application.event.IValueChangedListener;
import com.ulcjava.base.application.event.ValueChangedEvent;
import com.ulcjava.base.server.IDispatcher;

public class ULCDateSpinner extends ULCComponent implements IEnabler, IHasChangedSource {
	public final static String VALUECHANGED_CATEGORY = "valueChanged" ;

	private static final String VALUE_PROP = "value";
	protected Date value = null ;
	
	protected class ULCSpinnerDispatcher extends ULCComponentDispatcher {
		public void updateValue(Date value) {
			ULCDateSpinner.this.value = value ;
		}
    }
	
	public ULCDateSpinner() {
		this(new Date());
	}
	
	public ULCDateSpinner(Date value) {
		this.value = value ;
	}

	@Override
	protected IDispatcher createDispatcher() {
		return new ULCSpinnerDispatcher();
	}
	
	@Override
	protected String getPropertyPrefix() {
		return "ULCDateSpinner";
	}

	@Override
	protected String typeString() {
		return "com.filemaker.client.UIDateSpinner";
	}

	public void addValueChangedListener(IValueChangedListener listener) {
    	addListener(VALUECHANGED_CATEGORY,listener);
    }
   
    public void removeValueChangedListener(IValueChangedListener listener) {
    	removeListener(VALUECHANGED_CATEGORY,listener);
    }
    
   @Override
	protected void uploadStateUI() {
	   	super.uploadStateUI();
		createStateUI(new Object[] {value});
	}
	
	public Date getValue() {
    	return value;
    }

	public void setValue(Date value) {
		this.value = (Date) setStateUI(VALUE_PROP, this.value, value);
	}
}