/**
 * @author Sandro <sandro.pedrazzini@canoo.com>
 */

package com.canoo.ulc.community.datechooser.client.widget.util;

import java.awt.*;

public class GraphicMemento {

    private  Font fDaysFont = new Font("Dialog", Font.PLAIN, 10);
    private  Font fHighlightFont = new Font("Dialog", Font.BOLD, 12);
    private  Font fLabelsFont = new Font("Dialog", Font.PLAIN, 11);

    /**
     * Insets for day components and small buttons.
     */
    private static  Insets fInsets = new Insets(2, 2, 2, 2);

    private Color fTodayHighlight = new Color(255, 255, 104);
    private Color fDialogBackgroundColor = null;
    private Color fEnabledCellColor = Color.white;
    private Color fDisabledCellColor = new Color(204, 204, 204);

    private  int fCellWith = 26;
    private  int fCellHigh = 20;
    private  int fBorder = 10;
    private boolean fEnableCurrentDayView = true;

    public void enableCurrentDayView() {
        fEnableCurrentDayView = true;
    }

    public void disableCurrentDayView() {
        fEnableCurrentDayView = false;
    }

    public boolean isEnabledCurrentDayView(){
        return fEnableCurrentDayView;
    }

    public  Font getDaysFont() {
        return fDaysFont;
    }

    public  void setDaysFont(Font daysFont) {
        fDaysFont = daysFont;
    }

    public Font getHighlightFont() {
        return fHighlightFont;
    }

    public void setHighlightFont(Font highlightFont) {
        fHighlightFont = highlightFont;
    }

    public Font getLabelsFont() {
        return fLabelsFont;
    }

    public void setLabelsFont(Font labelsFont) {
        fLabelsFont = labelsFont;
    }

    public Insets getInsets() {
        return fInsets;
    }

    public void setInsets(Insets insets) {
       fInsets = insets;
    }

    public Color getTodayHighlight() {
        return fTodayHighlight;
    }

    public void setTodayHighlight(Color todayHighlight) {
        fTodayHighlight = todayHighlight;
    }

    public Color getDialogBackgroundColor() {
        return fDialogBackgroundColor;
    }

    public void setDialogBackgroundColor(Color color) {
        fDialogBackgroundColor = color;
    }

    public Color getEnabledCellColor() {
        return fEnabledCellColor;
    }

    public void setEnabledCellColor(Color enabledCellColor) {
        fEnabledCellColor = enabledCellColor;
    }

    public Color getDisabledCellColor() {
        return fDisabledCellColor;
    }

    public void setDisabledCellColor(Color disabledCellColor) {
        fDisabledCellColor = disabledCellColor;
    }

    public Dimension getCellDimension(){
       return new Dimension(getCellWidth(),getCellHight());
    }

    public int getCellWidth() {
        return fCellWith;
    }

    public void setCellWidth(int cellWith) {
        fCellWith = cellWith;
    }

    public int getCellHight() {
        return fCellHigh;
    }

    public void setCellHight(int cellHigh) {
        fCellHigh = cellHigh;
    }

    public int getBorder() {
        return fBorder;
    }

    public void setBorder(int border) {
        fBorder = border;
    }

    public int getButtonWidth() {
        return 5 * getCellWidth();
    }

    public int getButtonHight() {
        return 2 + getCellHight();
    }

    public int getPanelWidth() {
        return 7 * getCellWidth() + 2 * getBorder() + 1;
    }

    public int getPanelHigh() {
        return getNavigationBarHigh() + 7 * getCellHight() + getCancelButtonPanelHigh() + 2 * getBorder() + 1;
    }

    private int getCancelButtonPanelHigh() {
        return 2 * getCellHight();
    }

    private int getNavigationBarHigh() {
        return 2 * getCellHight();
    }

}
