/**
 * @author Sandro <sandro.pedrazzini@canoo.com>
 */

package com.canoo.ulc.community.datechooser.application;

import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

import com.ulcjava.base.application.AbstractApplication;
import com.ulcjava.base.application.ULCBoxPane;
import com.ulcjava.base.application.ULCFrame;
import com.ulcjava.base.application.ULCRootPane;
import com.ulcjava.base.application.ULCTextField;
import com.ulcjava.base.development.DevelopmentRunner;


public class ULCDateChooserSample extends AbstractApplication {
    public void start() {
        ULCRootPane frame = createRootPane();
        ULCBoxPane box = new ULCBoxPane();
        final ULCTextField textField = new ULCTextField(20);
        Calendar fromDate = Calendar.getInstance();
        fromDate.set(Calendar.MONTH, 10);
        Calendar toDate = Calendar.getInstance();
        toDate.set(Calendar.MONTH, 3);
        toDate.set(Calendar.YEAR, Calendar.getInstance().get(Calendar.YEAR) + 1);
        //ULCDateChooser dateChooser = new ULCDateChooser(Locale.GERMAN, "Cancel");
        ULCDateChooser dateChooser = new ULCDateChooser();
        //Date current = dateChooser.getSelectedDate();

        dateChooser.setFromDate(fromDate.getTime());
        dateChooser.setToDate(toDate.getTime());
        dateChooser.setSelectedDate(null);
        dateChooser.addDateSelectedListener(new IDateSelectedListener() {
            public void dateChosen(DateSelectedEvent selectedEvent) {
                textField.setText(selectedEvent.getDateAsString());
                System.err.println("selection performed...." + selectedEvent.getDate());
                System.err.println("As string.............." + selectedEvent.getDateAsString());
            }
        });
        box.add(ULCBoxPane.BOX_LEFT_CENTER, textField);
        box.add(ULCBoxPane.BOX_LEFT_TOP, dateChooser);
        frame.add(box);
        frame.setVisible(true);
    }

    protected ULCRootPane createRootPane() {
        ULCFrame frame = new ULCFrame("DateChooser Sample");
//        frame.setIconImage(new ULCIcon(getClass().getResource("/application.png")));
        frame.setDefaultCloseOperation(ULCFrame.TERMINATE_ON_CLOSE);
        return frame;
    }

    public static void main(String[] args) {
        DevelopmentRunner.setApplicationClass(ULCDateChooserSample.class);
        DevelopmentRunner.main(args);
    }
}

