package com.canoo.ulc.community.filetransfer.application;

import com.ulcjava.base.application.ULCAlert;
import com.ulcjava.base.application.BorderFactory;
import com.ulcjava.base.application.ULCDialog;
import com.ulcjava.base.application.util.Dimension;
import com.ulcjava.base.application.border.ULCAbstractBorder;
import com.canoo.ulc.community.progresspane.application.ITaskList;
import com.canoo.ulc.community.progresspane.application.ULCProgressPane;
import com.canoo.ulc.community.progresspane.application.TaskControllerAdapter;

/**
 * @author christian.stettler@canoo.com
 * @author Michael Brohl (michael.brohl@agrenon.com) ULC 6.1 port
 */
public class Utils {
    private Utils() {
    }

    public static void showMessageDialog(String title, String message, int type) {
        ULCAlert alert = new ULCAlert(title, message, "OK");
        alert.setMessageType(type);
        alert.show();
    }

    public static ULCAbstractBorder createMarginBorder(int margin) {
        return BorderFactory.createEmptyBorder(margin, margin, margin, margin);
    }

    public static void startWithProgressDialog(ITaskList taskList, String title) {
        ULCProgressPane progressPane = new ULCProgressPane(taskList);

        final ULCDialog dialog = new ULCDialog(null, title, true);
        dialog.getContentPane().add(progressPane);
        dialog.getContentPane().setBorder(createMarginBorder(5));
        dialog.setSize(new Dimension(500, 100));
        dialog.setVisible(true);

        progressPane.addTaskControllerListener(new TaskControllerAdapter() {
            public void completed() {
                dialog.setVisible(false);
            }

            public void stopped() {
                dialog.setVisible(false);
            }

            public void error(Exception e) {
                dialog.setVisible(false);
            }
        });

        progressPane.start();
    }
}
