package com.canoo.ulc.community.filetransfer.client;

import javax.swing.LookAndFeel;
import javax.swing.UIManager;

import com.jgoodies.plaf.LookUtils;
import com.jgoodies.plaf.Options;
import com.jgoodies.plaf.plastic.PlasticXPLookAndFeel;
import com.jgoodies.plaf.plastic.theme.SkyYellow;

/**
 * @author etienne.studer@canoo.com
 * @author Michael Brohl (michael.brohl@agrenon.com) ULC 6.1 port
 */
public class UIManagerHelper {
    public static void setJGoodiesLookAndFeelOnWindows() {
        if (isWindowsOS()) {
            JGoodiesHelper.setJGoodiesLookAndFeel();
        }
    }

    private static boolean isWindowsOS() {
        String os = System.getProperty("os.name").toLowerCase();
        return os.indexOf("windows") > -1;
    }

    private static void setLookAndFeel(LookAndFeel lookAndFeel) {
        try {
            UIManager.setLookAndFeel(lookAndFeel);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void setSystemLookAndFeel() {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Setting the JGoodies L&F is done through this inner static class, in
     * order to avoid that the JGoodies classes are unnecessarily loaded if not
     * needed. This allows for optimization of jar file download to the
     * client-side. <p/> e.g., in the case of JNLP deployment, we might not want
     * to set the JGoodies L&F on Mac systems, and we can hereby avoid that the
     * JGoodies jar file is unnecessarily downloaded to a Mac client.
     */
    private static class JGoodiesHelper {
        private static void setJGoodiesLookAndFeel() {
            Options.setUseNarrowButtons(true);
            Options.setUseSystemFonts(true);

            UIManager.put("ClassLoader", LookUtils.class.getClassLoader());

            PlasticXPLookAndFeel.setMyCurrentTheme(new SkyYellow());
            setLookAndFeel(new PlasticXPLookAndFeel());
        }
    }
}
