package com.canoo.ulc.community.filetransfer.application;

import com.ulcjava.base.application.AbstractApplication;
import com.ulcjava.base.application.ULCFrame;
import com.ulcjava.base.application.ULCRootPane;
import com.ulcjava.base.application.ULCTabbedPane;
import com.ulcjava.base.application.util.Dimension;

/**
 * @author christian.stettler@canoo.com
 * @author Michael Brohl (michael.brohl@agrenon.com) ULC 6.1 port
 */
public class FileTransferSample extends AbstractApplication {
    private ULCRootPane fRootPane;
    private ULCTabbedPane fTabbedPane;
    private FileUploadPane fFileUploadPane;
    private FileDownloadPane fFileDownloadPane;

    public void start() {
        initComponents();
        layoutComponents();

        show();
    }

    private void initComponents() {
        fRootPane = createRootPane();
        fTabbedPane = new ULCTabbedPane();
        fFileUploadPane = new FileUploadPane();
        fFileDownloadPane = new FileDownloadPane();
    }

    protected ULCRootPane createRootPane() {
        ULCFrame frame = new ULCFrame("File Transfer ULC 6.1 Sample");
        frame.setDefaultCloseOperation(ULCFrame.TERMINATE_ON_CLOSE);

        return frame;
    }

    private void layoutComponents() {
        fTabbedPane.addTab(fFileUploadPane.getName(), fFileUploadPane);
        fTabbedPane.addTab(fFileDownloadPane.getName(), fFileDownloadPane);
        fTabbedPane.setPreferredSize(new Dimension(500, 280));

        fRootPane.getContentPane().setBorder(Utils.createMarginBorder(5));
        fRootPane.getContentPane().add(fTabbedPane);
    }

    private void show() {
        fRootPane.setVisible(true);
    }
}
