/*
 * Copyright  2000-2004 Canoo Engineering AG, Switzerland.
 */

package com.canoo.ulc.community.linksupport.client;

import com.canoo.ulc.community.linksupport.shared.LinkUtilities;
import com.ulcjava.base.client.UITextArea;
import com.ulcjava.base.shared.IUlcEventConstants;
import com.ulcjava.base.shared.internal.Anything;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

public class UILinkTextArea extends UITextArea {
    public void restoreState(Anything args) {
        super.restoreState(args);

        getBasicComponent().addMouseListener(new ActionHandler());
        getBasicComponent().addMouseMotionListener(new ActionHandler());
    }

//    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
//        String htmlValue = LinkUtilities.convertToHtml((String)value);
//        return super.getTableCellRendererComponent(table, htmlValue, isSelected, hasFocus, row, column);
//    }

    private class ActionHandler extends MouseAdapter implements MouseMotionListener {
        public void mouseMoved(MouseEvent event) {
            if (isOverLink(event.getPoint())) {
                getBasicComponent().setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
            } else {
                getBasicComponent().setCursor(null);
            }
        }

        public void mouseDragged(MouseEvent event) {
        }

        public void mousePressed(MouseEvent event) {
            if (isOverLink(event.getPoint())) {
                sendOptionalEventULC(IUlcEventConstants.ACTION_EVENT, IUlcEventConstants.ACTION_PERFORMED);
            }
        }

        private boolean isOverLink(Point point) {
            Dimension preferredSize = getBasicComponent().getPreferredSize();
            return point.x < preferredSize.width && point.y < preferredSize.height;
        }
    }
}
