/*
 * Copyright  2000-2004 Canoo Engineering AG, Switzerland.
 */
package com.canoo.ulc.community.linksupport.client.environment;

//import com.jgoodies.plaf.Options;
//import com.jgoodies.plaf.plastic.Plastic3DLookAndFeel;
//import com.jgoodies.plaf.plastic.PlasticLookAndFeel;
//import com.jgoodies.plaf.plastic.theme.SkyBlue;
import com.ulcjava.base.shared.internal.IllegalStateException;

import javax.swing.*;
import java.awt.*;

public class UIManagerUtilities {
    private UIManagerUtilities() {
    }

    public static void initUIManager() {
        ensureNiceLookAndFeel();
        ensureNiceSampleDefaults();
    }

    private static void ensureNiceLookAndFeel() {
        try {
            if ("1.5".equals(System.getProperty("java.specification.version"))) {
                // for JRE 1.5 we want the default look & feel: Ocean or system look and feel (Mac)
                return;
            } else if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
                // on windows we want a custom look & feel: Plastic3D from JGoodies
//                PlasticLookAndFeel.setMyCurrentTheme(new SkyBlue());
//                UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
//                UIManager.setLookAndFeel(new Plastic3DLookAndFeel());
            } else {
                // in all other cases we want the system look & feel
                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            }
        } catch (Exception e) {
            throw new IllegalStateException("could not ensure nice look & feel", e);
        }
    }

    private static void ensureNiceSampleDefaults() {
        // take care: this removes the focus border for all tables, not just the link table instances!
        UIManager.getDefaults().put("Table.focusCellHighlightBorder", BorderFactory.createEmptyBorder(1, 1, 1, 1));
        // take care: this removes the header border for all tables, not just the link table instances!
        UIManager.getDefaults().put("TableHeader.cellBorder", BorderFactory.createLineBorder(Color.white));
    }
}
