/*
 * Copyright  2000-2004 Canoo Engineering AG, Switzerland.
 */
package com.canoo.ulc.community.linksupport.application;

import com.canoo.ulc.community.linksupport.shared.LinkUtilities;
import com.ulcjava.base.application.ULCLabel;
import com.ulcjava.base.application.event.ActionEvent;
import com.ulcjava.base.application.event.IActionListener;
import com.ulcjava.base.application.util.ULCIcon;
import com.ulcjava.base.shared.IUlcEventConstants;
import com.ulcjava.base.shared.internal.Anything;


public class ULCLinkLabel extends ULCLabel {
	
//	private boolean enabled = true;
	
    public ULCLinkLabel() {
        this("", null, LEADING);
    }

    public ULCLinkLabel(ULCIcon icon) {
        this(null, icon, CENTER);
    }

    public ULCLinkLabel(ULCIcon icon, int horizontalAlignment) {
        this(null, icon, horizontalAlignment);
    }

    public ULCLinkLabel(String text) {
        this(text, null, LEADING);
    }

    public ULCLinkLabel(String text, int horizontalAlignment) {
        this(text, null, horizontalAlignment);
    }

    public ULCLinkLabel(String text, ULCIcon icon, int horizontalAlignment) {
        super(LinkUtilities.convertToHtml(text), icon, horizontalAlignment);
    }

    // temp workaround until real button is implemented
    public void setText(String text, boolean underline) {
    	if (underline) {
    		setText(text);
    	} else {
    		super.setText(text);
    	}
    }
    
    public void setText(String text) {
        super.setText(LinkUtilities.convertToHtml(text));
    }
    
//    public void setEnabled(boolean state) {
//    	this.enabled = enabled;
//    }

    public void addActionListener(IActionListener listener) {
        internalAddListener(IUlcEventConstants.ACTION_EVENT, listener);
    }

    public void removeActionListener(IActionListener listener) {
        internalRemoveListener(IUlcEventConstants.ACTION_EVENT, listener);
    }

    protected void handleEvent(int listenerType, int eventId, Anything args) {
		if (isEnabled()) {
			if (listenerType == IUlcEventConstants.ACTION_EVENT) {
				distributeToListeners(new ActionEvent(this, null));
			} else {
				super.handleEvent(listenerType, eventId, args);
			}
		}
	}

    protected String typeString() {
        return "com.canoo.ulc.community.linksupport.client.UILinkLabel";
    }
}
