/*
 * Copyright  2000-2004 Canoo Engineering AG, Switzerland.
 */
package com.canoo.ulc.community.linksupport.application;

import com.canoo.ulc.community.linksupport.shared.LinkUtilities;
import com.ulcjava.base.application.ULCTextArea;
import com.ulcjava.base.application.event.ActionEvent;
import com.ulcjava.base.application.event.IActionListener;
import com.ulcjava.base.application.util.ULCIcon;
import com.ulcjava.base.shared.IUlcEventConstants;
import com.ulcjava.base.shared.internal.Anything;


public class ULCLinkTextArea extends ULCTextArea {
	
	private static ULCLinkLabel label = new ULCLinkLabel();
	
    public ULCLinkTextArea() {
        this("");
    }

    public ULCLinkTextArea(String text) {
        super(text);
        setWrapStyleWord(true);
        setEditable(false);
        setLineWrap(true);
        setFont(label.getFont());
    }

    // temp workaround until real button is implemented
    public void setText(String text, boolean underline) {
    	if (underline) {
    		setText(text);
    	} else {
    		super.setText(text);
    	}
    }
    
    public void setText(String text) {
        super.setText(LinkUtilities.convertToHtml(text));
    }
    
//    public void setEnabled(boolean state) {
//    	this.enabled = enabled;
//    }

    public void addActionListener(IActionListener listener) {
        internalAddListener(IUlcEventConstants.ACTION_EVENT, listener);
    }

    public void removeActionListener(IActionListener listener) {
        internalRemoveListener(IUlcEventConstants.ACTION_EVENT, listener);
    }

    protected void handleEvent(int listenerType, int eventId, Anything args) {
		if (isEnabled()) {
			if (listenerType == IUlcEventConstants.ACTION_EVENT) {
				distributeToListeners(new ActionEvent(this, null));
			} else {
				super.handleEvent(listenerType, eventId, args);
			}
		}
	}

    protected String typeString() {
        return "com.canoo.ulc.community.linksupport.client.UILinkTextArea";
    }
}
